# coding=utf-8

def analyze_mot_file(filename):
	print 'Reading "%s"' % filename
	f = open(filename)

	addr = []
	data = []
	start_addr = 0
	
	for line in f:
		line = line.rstrip()
		record_type = line[0:2]

		if record_type == "S0":
			continue

		elif record_type == "S1":
			n_bytes = int(line[2:4], 16)
			addr.append(int(line[4:8], 16))
			line = line[8:]
			data_line = ""
			for i in range(n_bytes-2-1):
				byte = line[i*2:i*2+2]
				data_line += chr(int(byte, 16))
			data.append(data_line)

		elif record_type == "S2":
			n_bytes = int(line[2:4], 16)
			addr.append(int(line[4:10], 16))
			line = line[10:]
			data_line = ""
			for i in range(n_bytes-3-1):
				byte = line[i*2:i*2+2]
				data_line += chr(int(byte, 16))
			data.append(data_line)

		elif record_type == "S3":
			n_bytes = int(line[2:4], 16)
			addr.append(int(line[4:12], 16))
			line = line[12:]
			data_line = ""
			for i in range(n_bytes-4-1):
				byte = line[i*2:i*2+2]
				data_line += chr(int(byte, 16))
			data.append(data_line)

		elif record_type == "S4":
			continue

		elif record_type == "S5":
			continue

		elif record_type == "S6":
			continue

		elif record_type == "S7":
			n_bytes = int(line[2:4], 16)
			start_addr = (int(line[4:12], 16))

		elif record_type == "S8":
			n_bytes = int(line[2:4], 16)
			start_addr = (int(line[4:10], 16))

		elif record_type == "S9":
			n_bytes = int(line[2:4], 16)
			start_addr = (int(line[4:8], 16))
		else:
			continue

	print "    Number of data records: %d" % len(addr)
	print "    Start address: 0x%08x" % start_addr
	f.close()

	return (addr, data, start_addr)


def reconstruct_records(addr, data, size):
	print "Reconstructing data records..."

	i = 0;
	while i < len(addr) - 1:
		# アドレスが連続しているときはレコードをまとめる
		if addr[i] + len(data[i]) == addr[i+1]:
			# 次のレコードを現在のレコードに付け加える
			# 次のレコード全て現在のレコードに付け加えられるとき
			if len(data[i]) + len(data[i+1]) <= size:
				data[i] += data[i+1]
				del addr[i+1]
				del data[i+1]
			# 次のレコードの一部を現在のレコードに付け加える
			else:
				n = size - len(data[i])
				data[i] += data[i+1][:n]
				data[i+1] = data[i+1][n:]
				addr[i+1] += n
				i += 1
		else:
			i += 1

	print "    Number of data records: %d" % len(addr)
	return (addr, data)

