# coding=utf-8

ACK = chr(0x06)

# Table 17.12 (Hardware Manual Rev.5.00, English, p.635)
cmd_code = {}
cmd_code["Inquiry_on_supported_devices"]            = chr(0x20)
cmd_code["Device_selection"]                        = chr(0x10)
cmd_code["Inquiry_on_clock_modes"]                  = chr(0x21)
cmd_code["Clock-mode_selection"]                    = chr(0x11)
cmd_code["Inquiry_on_frequency_multipliers"]        = chr(0x22)
cmd_code["Inquiry_on_operating_frequency"]          = chr(0x23)
cmd_code["Inquiry_on_user_MATs"]                    = chr(0x25)
cmd_code["Inquiry_on_erasure_blocks"]               = chr(0x26)
cmd_code["Inquiry_on_programming_size"]             = chr(0x27)
cmd_code["New_bit_rate_selection"]                  = chr(0x3F)
cmd_code["Transition_to_programming/erasure_state"] = chr(0x40)

# Table 17.13 (Hardware Manual Rev.5.00, English, p.648)
cmd_code["Selection_of_user_MAT_programming"]       = chr(0x43)
cmd_code["128-byte_programming"]                    = chr(0x50)
cmd_code["Erasure_selection"]                       = chr(0x48)
cmd_code["Block_erasure"]                           = chr(0x58)
cmd_code["Memory_read"]                             = chr(0x52)
cmd_code["Sum_checking_of_user_MAT"]                = chr(0x4B)
cmd_code["Blank_checking_of_user_MAT"]              = chr(0x4D)
cmd_code["Inquiry_on_boot_program_state"]           = chr(0x4F)

# Table 17.14 (Hardware Manual Rev.5.00, English, p.657)
status_code = {}
status_code[chr(0x11)] = "Waiting for device selection"
status_code[chr(0x12)] = "Waiting for clock-mode selection"
status_code[chr(0x13)] = "Waiting for bit-rate selection"
status_code[chr(0x1F)] = "Waiting for transition to programming/erasure status (bit-rate selection complete)"
status_code[chr(0x31)] = "Erasing the user MAT"
status_code[chr(0x3F)] = "Waiting for programming/erasure selection (erasure complete)"
status_code[chr(0x4F)] = "Waiting to receive data for programming (programming complete)"
status_code[chr(0x5F)] = "Waiting for erasure block specification (erasure complete)"

# Table 17.15 (Hardware Manual Rev.5.00, English, p.658)
error_code = {}
error_code[chr(0x00)] =  "No error"
error_code[chr(0x11)] =  "Sum check error"
error_code[chr(0x21)] =  "Non-matching device code error"
error_code[chr(0x22)] =  "Non-matching clock mode error"
error_code[chr(0x24)] =  "Bit-rate selection failure"
error_code[chr(0x25)] =  "Input frequency error"
error_code[chr(0x26)] =  "Frequency multiplier error"
error_code[chr(0x27)] =  "Operating frequency error"
error_code[chr(0x29)] =  "Block number error"
error_code[chr(0x2A)] =  "Address error"
error_code[chr(0x2B)] =  "Data length error (size error)"
error_code[chr(0x51)] =  "Erasure error"
error_code[chr(0x52)] =  "Non-erased error"
error_code[chr(0x53)] =  "Programming error"
error_code[chr(0x54)] =  "Selection processing error"
error_code[chr(0x80)] =  "Command error"
error_code[chr(0xFF)] =  "Bit-rate matching acknowledge error"

